MooseX::Daemonize(3p)

NAME
MooseX::Daemonize - Role for daemonizing your Moose based application

VERSION
This document describes MooseX::Daemonize version 0.05

SYNOPSIS
    package My::Daemon;
    use Moose;

    with qw(MooseX::Daemonize);

    # ... define your class ....

    after start => sub {
        my $self = shift;
        return unless $self->is_daemon;
        # your daemon code here ...
    };

    # then in your script ...

    my $daemon = My::Daemon->new_with_options();

    my ($command) = @{$daemon->extra_argv}
    defined $command || die "No command specified";

    $daemon->start   if $command eq 'start';
    $daemon->status  if $command eq 'status';
    $daemon->restart if $command eq 'restart';
    $daemon->stop    if $command eq 'stop';

    warn($daemon->status_message);
    exit($daemon->exit_code);

DESCRIPTION
Often you want to write a persistant daemon that has a pid file, and responds appropriately to Signals. This module provides a set of basic roles as an infrastructure to do that.

CAVEATS
When going into background MooseX::Daemonize closes all open file handles. This may interfere with you logging because it may also close the log file handle you want to write to. To prevent this you can either defer opening the log file until after start. Alternatively, use can use the 'dont_close_all_files' option either from the command line or in your .sh script.

Assuming you want to use Log::Log4perl for example you could expand the MooseX::Daemonize example above like this.

    after start => sub {
        my $self = shift;
        return unless $self->is_daemon;
        Log::Log4perl->init(\$log4perl_config);
        my $logger = Log::Log4perl->get_logger();
        $logger->info("Daemon started");
        # your daemon code here ...
    };

ATTRIBUTES
This list includes attributes brought in from other roles as well we include them here for ease of documentation. All of these attributes are settable though MooseX::Getopt's command line handling, with the exception of "is_daemon".

progname Path::Class::Dir | Str
    The name of our daemon, defaults to "$package_name =~ s/::/_/";

pidbase Path::Class::Dir | Str
    The base for our PID, defaults to "/var/run/"

pidfile MooseX::Daemonize::Pid::File | Str
    The file we store our PID in, defaults to "$pidbase/$progname.pid"

foreground Bool
    If true, the process won't background. Useful for debugging. This option can be set via Getopt's -f.

no_double_fork Bool
    If true, the process will not perform the typical double-fork, which is extra added protection from your process accidentally aquiring a controlling terminal. More information can be found by Googling "double fork daemonize".

ignore_zombies Bool
    If true, the process will not clean up zombie processes. Normally you don't want this.

dont_close_all_files Bool
    If true, the objects open filehandles will not be closed when daemonized. Normally you don't want this.

is_daemon Bool
    If true, the process is the backgrounded daemon process, if false it is the parent process. This is useful for example in an "after 'start' =" sub { }> block.

    NOTE: This option is explicitly not available through MooseX::Getopt.

stop_timeout
    Number of seconds to wait for the process to stop, before trying harder to kill it. Defaults to 2 seconds.

These are the internal attributes, which are not available through MooseX::Getopt.

exit_code Int
status_message Str

METHODS

  Daemon Control Methods
These methods can be used to control the daemon behavior. Every effort has been made to have these methods DWIM (Do What I Mean), so that you can focus on just writing the code for your daemon.

Extending these methods is best done with the Moose method modifiers, such as "before", "after" and "around".

start
    Setup a pidfile, fork, then setup the signal handlers.

stop
    Stop the process matching the pidfile, and unlinks the pidfile.

restart
    Literally this is:

        $self->stop();
        $self->start();

status
shutdown

  Pidfile Handling Methods

init_pidfile
    This method will create a MooseX::Daemonize::Pid::File object and tell it to store the PID in the file "$pidbase/$progname.pid".

check
    This checks to see if the daemon process is currently running by checking the pidfile.

get_pid
    Returns the PID of the daemon process.

save_pid
    Write the pidfile.

remove_pid
    Removes the pidfile.

  Signal Handling Methods

setup_signals
    Setup the signal handlers, by default it only sets up handlers for SIGINT and SIGHUP. If you wish to add more signals just use the "after" method modifier and add them.

handle_sigint
    Handle a INT signal, by default calls "$self-"stop()>

handle_sighup
    Handle a HUP signal. By default calls "$self-"restart()>

  Exit Code Methods
These are overriable constant methods used for setting the exit code.

OK  Returns 0.

ERROR
    Returns 1.

  Introspection

meta()
    The "meta()" method from Class::MOP::Class

DEPENDENCIES
Moose, MooseX::Getopt, MooseX::Types::Path::Class and POSIX

INCOMPATIBILITIES
None reported. Although obviously this will not work on Windows.

BUGS AND LIMITATIONS
No bugs have been reported.

Please report any bugs or feature requests to "bug-acme-dahut-call@rt.cpan.org", or through the web interface at <http://rt.cpan.org>.

SEE ALSO
Proc::Daemon, Daemon::Generic

AUTHORS
Chris Prather "<chris@prather.org"

Stevan Little "<stevan.little@iinteractive.com>"

THANKS
Mike Boyko, Matt S. Trout, Stevan Little, Brandon Black, Ash Berlin and the #moose denzians

Some bug fixes sponsored by Takkle Inc.

LICENCE AND COPYRIGHT
Copyright (c) 2007-2011, Chris Prather "<chris@prather.org>". Some rights reserved.

This module is free software; you can redistribute it and/or modify it under the same terms as Perl itself. See perlartistic.

DISCLAIMER OF WARRANTY
BECAUSE THIS SOFTWARE IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH YOU. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR CORRECTION.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE SOFTWARE AS PERMITTED BY THE ABOVE LICENCE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE SOFTWARE TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.